<?PHP if (!defined('PmWiki')) exit();

/*
 ***** 
 *
 * EditFunctionInjection allows a site administrator to easily
 *    place EditFunctions where he wants to
 *
 * Copyright 2017 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****
*/

# Injects a edit function in the right place
# where you need it, independently from
# where you call it on config.php

# f = function_name;
# p = place_to_inject (<before or >after);
# b = begin ; e = end;
function EditFunctionInject($f,$p){ 
global $EditFunctions;
  if($f == '' || $p == '') return;
  if($p == "b"){array_unshift($EditFunctions, $f);return;}
  if($p == "e"){array_push($EditFunctions,$f);return;}
  if($p != "b" || $p != "e" ){
    $NewEditFunctions = array();
    foreach($EditFunctions as $k => $v){
      if($p != "<".$v && $p != ">".$v)
        $NewEditFunctions[] = $v;
      if($p == "<".$v){
        $NewEditFunctions[] = $f;   
        $NewEditFunctions[] = $v;
      }
      if($p == ">".$v){
        $NewEditFunctions[] = $v;
        $NewEditFunctions[] = $f;   
      }
    }
   $EditFunctions = $NewEditFunctions;
  }
  return; 
}
  
